/* $Id: jigdo.cc,v 1.13 2002/01/01 19:00:58 richard Exp $ -*- C++ -*-
  __   _
  |_) /|  Copyright (C) 2001 Richard Atterer
  | \/|  <richard@atterer.net>
   '` 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2 or
  later. See the file COPYING for details.

*/

#include <iostream>
namespace std { }
using namespace std;
#include <stdio.h>

#include <config.h>
#include <debug.hh>
#include <libwww.hh>
#include <glibwww.hh>
#include <gtk-gui.hh>
#include <gtk-support.hh>
//______________________________________________________________________

namespace {

  extern "C"
  int printer(const char * fmt, va_list pArgs) {
    return vfprintf(stdout, fmt, pArgs);
  }
//______________________________________________________________________

  // Initialize (g)libwww
  void initLibwww() {
    HTAlertInit();
    HTAlert_setInteractive(YES);
    HTPrint_setCallback(printer);
    glibwww_init("jigdo", JIGDO_VERSION);
    /* Register a number of libwww filters which "do the right thing"
       when encountering things such as HTTP redirects. */
//     HTBeforeInit();
//     HTAfterInit();

//     HTNet_addAfter(HTRedirectFilter, 0/*template*/, 0/*param*/,
//                    HT_PERM_REDIRECT | HT_TEMP_REDIRECT);
// extern BOOL HTNet_addBefore (HTNetBefore * before, const char * tmplate,
//                              void * param, HTFilterOrder order);
// extern BOOL HTNet_addAfter (HTNetAfter * after, const char * tmplate,
//                             void * param, int status,
//                             HTFilterOrder order);


  }

} // namespace
//______________________________________________________________________

int main (int argc, char *argv[]) {

# if ENABLE_NLS
  bindtextdomain(PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain(PACKAGE);
# endif

  // Initialize GTK+ and display window
  gtk_set_locale();
  gtk_init(&argc, &argv);
  add_pixmap_directory(PACKAGE_DATA_DIR DIRSEPS "pixmaps");
  GUI::create();
  gtk_widget_show(GUI::window.window);

  initLibwww();

  gtk_main();
  return 0;
}
