/* $Id: sstream.cc,v 1.1 2002/01/25 11:14:47 richard Exp $ -*- C++ -*-
  __   _
  |_) /|  Copyright (C) 2002 Richard Atterer
  | \/|  <richard@atterer.net>
   '` 
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License, version 2. See
  the file COPYING for details.

  Compatibility layer in case of missing <sstream>

*/

#include <sstream.hh>
//______________________________________________________________________

#if !HAVE_SSTREAM

char ostringstream::buf[];

ostringstream& ostringstream::put(int x) {
  snprintf(buf, BUF_SIZE, "%d", x);
  buf[BUF_SIZE - 1] = '\0';
  val += buf;
  return *this;
}

ostringstream& ostringstream::put(unsigned x) {
  snprintf(buf, BUF_SIZE, "%u", x);
  buf[BUF_SIZE - 1] = '\0';
  val += buf;
  return *this;
}

ostringstream& ostringstream::put(long x) {
  snprintf(buf, BUF_SIZE, "%ld", x);
  buf[BUF_SIZE - 1] = '\0';
  val += buf;
  return *this;
}

ostringstream& ostringstream::put(unsigned long x) {
  snprintf(buf, BUF_SIZE, "%lu", x);
  buf[BUF_SIZE - 1] = '\0';
  val += buf;
  return *this;
}

ostringstream& ostringstream::put(uint64 x) {
  snprintf(buf, BUF_SIZE, "%llu", x);
  buf[BUF_SIZE - 1] = '\0';
  val += buf;
  return *this;
}

// joblist.cc uses this
ostringstream& ostringstream::put(double x) {
  snprintf(buf, BUF_SIZE, "%.1f", x);
  buf[BUF_SIZE - 1] = '\0';
  val += buf;
  return *this;
}

#endif
